Index: GTP/trunk/App/Demos/Vis/CHC_revisited/BvhLoader.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/BvhLoader.cpp	(revision 2755)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/BvhLoader.cpp	(revision 2755)
@@ -0,0 +1,134 @@
+#include <queue>
+#include <stack>
+#include <fstream>
+#include <iostream>
+
+#include "BvhLoader.h"
+
+
+
+namespace CHCDemo
+{
+
+using namespace std;
+
+
+#define TYPE_INTERIOR -2
+#define TYPE_LEAF -3
+
+
+
+BvhLeaf *BvhLoader::ImportBinLeaf(ifstream &stream, BvhInterior *parent)
+{
+	BvhLeaf *leaf = new BvhLeaf(parent);
+
+	int first, last;
+
+	stream.read(reinterpret_cast<char *>(&first), sizeof(int));
+	stream.read(reinterpret_cast<char *>(&last), sizeof(int));
+
+	leaf->mFirst = first;
+	leaf->mLast = last;
+
+	return leaf;
+}
+
+
+BvhInterior *BvhLoader::ImportBinInterior(ifstream &stream, BvhInterior *parent)
+{
+	BvhInterior *interior = new BvhInterior(parent);
+
+	stream.read(reinterpret_cast<char *>(&interior->mAxis), sizeof(char));
+	stream.read(reinterpret_cast<char *>(&interior->mPosition), sizeof(float));
+
+	return interior;
+}
+
+
+BvhNode *BvhLoader::LoadNextNode(ifstream &stream, BvhInterior *parent)
+{
+	int nodeType;
+	stream.read(reinterpret_cast<char *>(&nodeType), sizeof(int));
+
+	if (nodeType == TYPE_LEAF)
+	{
+		//OUT1("l");
+		return ImportBinLeaf(stream, static_cast<BvhInterior *>(parent));
+	}
+
+	if (nodeType == TYPE_INTERIOR)
+	{
+		//OUT1("i");
+		return ImportBinInterior(stream, static_cast<BvhInterior *>(parent));
+	}
+
+	return NULL;
+}
+
+
+Bvh *BvhLoader::LoadFromFile(const string &filename,  
+							 const SceneEntityContainer &entities)
+{
+	// export binary version of mesh
+	queue<BvhNode *> tStack;
+	ifstream stream(filename.c_str(), ifstream::binary);
+
+	if (!stream.is_open()) return NULL;
+
+	cout << "loading bvh" << endl;
+	Bvh *bvh = new Bvh();
+
+	bvh->mGeometrySize = entities.size();
+	bvh->mGeometry = new SceneEntity*[bvh->mGeometrySize];
+
+	for (size_t i = 0; i < bvh->mGeometrySize; ++ i)
+		bvh->mGeometry[i] = entities[i];
+
+	bvh->mRoot = LoadNextNode(stream, NULL);
+
+	tStack.push(bvh->mRoot);
+	bvh->mNumNodes = 1;
+
+	while(!tStack.empty())
+	{
+		BvhNode *node = tStack.front();
+		tStack.pop();
+
+		if (!node->IsLeaf())
+		{
+			bvh->mNumNodes += 2;
+
+			BvhInterior *interior = static_cast<BvhInterior *>(node);
+
+            BvhNode *front = LoadNextNode(stream, interior);
+			BvhNode *back = LoadNextNode(stream, interior);
+	
+			interior->mFront = front;
+			interior->mBack = back;
+
+			front->mDepth = interior->mDepth + 1;
+			back->mDepth = interior->mDepth + 1;
+
+			tStack.push(front);			
+			tStack.push(back);
+		}
+	}
+
+	cout << "... finished loading " << bvh->mNumNodes << " nodes, updating boxes" << endl;
+
+	//adjust bounding boxes
+	//bvh->UpdateBoxes(bvh->mRoot);
+	//bvh->UpdateNumLeaves(bvh->mRoot);
+
+	// compute unique ids
+	//bvh->ComputeIds();
+	// update the indices of the geometry so we can render interiors as well
+	//bvh->UpdateInteriors(bvh->mRoot);
+	// do this once so at least the current node bounding box is tested
+	//bvh->RecomputeBounds();
+
+	return bvh;
+}
+
+
+}
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/BinaryLoader.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/BinaryLoader.cpp	(revision 2747)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/BinaryLoader.cpp	(revision 2755)
@@ -1,14 +1,16 @@
 #include "BinaryLoader.h"
-#include "yare.h"
-#include "yamath.h"
-#include "gzstream.h"
-#include "ImageComponent.h"
-#include "RenderState.h"
-#include "GeometryProcessor.h"
+#include "Matrix4x4.h"
+#include "Geometry.h"
+#include "Material.h"
+//#include "gzstream.h"
 
 
 using namespace std;
 
-static STL_MAP<String,Texture *> stlm_textures;
+
+namespace CHCDemo
+{
+
+/*static STL_MAP<String,Texture *> stlm_textures;
 
 
@@ -61,22 +63,25 @@
 
 	return myTexture;
-}
-
-
-Shape3D *BinaryLoader::LoadShape(igzstream &str)
+}*/
+
+
+//SceneEntity *BinaryLoader::LoadShape(igzstream &str)
+SceneEntity *BinaryLoader::LoadShape(ifstream &str)
 {	
 	Geometry *geom = LoadGeometry(str);
-	Appearance *app = LoadAppearance(str);
-
-	Shape3D *shape = new Shape3D(geom, app);
-
-	return shape;
-}
-
-
-Appearance *BinaryLoader::LoadAppearance(igzstream &str)
-{
-	Appearance *app = new Appearance();
-	
+	Material *mat = LoadMaterial(str);
+
+	Matrix4x4 *m;
+	SceneEntity *sceneGeom = new SceneEntity(geom, m, mat);
+
+	return sceneGeom;
+}
+
+
+//Appearance *BinaryLoader::LoadMaterial(igzstream &str)
+Material *BinaryLoader::LoadMaterial(ifstream &str)
+{
+	Material *mat = new Material();
+/*	
 	// texture
 	int texnameSize;
@@ -113,6 +118,4 @@
 		//str.read(reinterpret_cast<char *>(&spec), sizeof(Color3f));
 		//str.read(reinterpret_cast<char *>(&shine), sizeof(float));
-#if 1
-		Material *mat = new Material();
 
 		mat->setAmbientColor(amb);
@@ -123,13 +126,16 @@
 
 		app->setMaterial(mat);
-#endif
-	}
-
-	return app;
-}
-
-
-Geometry *BinaryLoader::LoadGeometry(igzstream &str)
-{
+	}
+
+	return app;*/
+
+	return mat;
+}
+
+
+//Geometry *BinaryLoader::LoadGeometry(igzstream &str)
+Geometry *BinaryLoader::LoadGeometry(ifstream &str)
+{
+/*
 	int vertexCount;
 	int stripCount;
@@ -254,9 +260,12 @@
 	
 	return geom; 
-}
-
-
-BranchGroup *BinaryLoader::Load(const string &filename)
-{
+	*/
+return 0;
+}
+
+
+bool BinaryLoader::Load(const std::string &filename, SceneEntityContainer &geometry)
+{
+#if 0
 	clear_textures(); // clear the texture table
 
@@ -320,38 +329,6 @@
 
 	return root;
-}
-
-
-#if 0
-
-collectvertices
-{
-	int newIndex = 0;
-
-	for (int i = 0; i < numTriangles; ++ i)
-	{
-		Triangle tri = mTriangles[i];
-
-		for (int j = 0; j < 3; ++ j)
-		{
-			const int index = tri.mVertexIndices[j];
-			if (!mHashtable[index])
-			{
-				mHashTable[index] = newIndex;
-				mNewVertices.push_back(mVertices[index];
-			}
-	}
-
-	// now loop again, exchange indices;
-	for (int i = 0; i < numTriangles; ++ i
-	{
-		Triangle tri = mTriangles[i];
-
-		for (int j = 0; j < 3; ++ j)
-		{
-			const int index = tri.mVertexIndices[j];
-			tri.mVertexIndices[j] = mHashTable[index];
-	}
-}
-
 #endif
+}
+
+}
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/RenderTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/RenderTraverser.h	(revision 2754)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/RenderTraverser.h	(revision 2755)
@@ -5,11 +5,9 @@
 #include <stack>
 #include "glInterface.h"
-
+#include "Bvh.h"
 
 namespace CHCDemo
 {
 
-class BvhNode;
-class Bvh;
 class Camera;
 class Matrix4x4;
@@ -44,4 +42,5 @@
 
 //typedef std::priority_queue<BvhNode *, std::vector<BvhNode *>, myless<std::vector<BvhNode *>::value_type> > TraversalQueue;
+typedef std::priority_queue<BvhNode *, std::vector<BvhNode *>, myless> TraversalQueue;
 
 /** Abstract class implementing a scene traversal for rendering.
@@ -112,6 +111,8 @@
 	void Switch2GLQueryState();
 
+	void EnqueueNode(BvhNode *node);
 
-protected:
+	////////////
+	//-- members
 
 	// /the current clip planes of the view frustum
@@ -126,5 +127,5 @@
 	Bvh *mBvh;
 	/// use a priority queue rather than a renderstack
-	//PriorityQueue mDistanceQueue; 
+	TraversalQueue mDistanceQueue; 
 	
 	int mFrameID;
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/AxisAlignedBox3.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/AxisAlignedBox3.cpp	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/AxisAlignedBox3.cpp	(revision 2755)
@@ -2,7 +2,9 @@
 #include <iostream>
 #include "AxisAlignedBox3.h"
+#include "Plane3.h"
 
 
 using namespace std;
+
 
 namespace CHCDemo
@@ -1027,8 +1029,48 @@
 		return mMin[face];
 	else
-			return mMax[face - 3];
-}
-
-
-}
-
+		return mMax[face - 3];
+}
+
+
+int AxisAlignedBox3::GetIndexNearestVertex(const Vector3 &vecPlaneNormal)
+{
+	int index;
+
+	if (vecPlaneNormal.x > 0.0f)
+		index = (vecPlaneNormal.y > 0.0f) ? 0 : 3;
+	else
+		index = (vecPlaneNormal.y > 0.0f) ? 1 : 2;
+
+	return (vecPlaneNormal.z > 0.0f) ? index : 7 - index;
+}
+
+
+int AxisAlignedBox3::GetIndexFarthestVertex(const Vector3 &vecPlaneNormal)
+{
+	int index;
+
+	if (vecPlaneNormal.x <= 0.0f)
+		index = (vecPlaneNormal.y <= 0.0f) ? 0 : 3;
+	else
+		index = (vecPlaneNormal.y <= 0.0f) ? 1 : 2;
+
+	return (vecPlaneNormal.z <= 0.0f) ? index : 7 - index;
+}
+
+
+float AxisAlignedBox3::GetDistance(int index, const Plane3 &plane) const
+{
+	return plane.Distance(GetVertex(index));
+}
+
+
+float AxisAlignedBox3::GetMinVisibleDistance(const Plane3 &near) const
+{
+	return	near.mNormal.x * ((near.mNormal.x > 0.0f) ? mMin.x : mMax.x) +
+			near.mNormal.y * ((near.mNormal.y > 0.0f) ? mMin.y : mMax.y) +
+			near.mNormal.z * ((near.mNormal.z > 0.0f) ? mMin.z : mMax.z) +
+			near.mD;
+}
+
+}
+
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.h	(revision 2753)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.h	(revision 2755)
@@ -5,5 +5,4 @@
 
 #include "Geometry.h"
-//#include "FlexibleHeap.h"
 
 
@@ -14,5 +13,5 @@
 // Forward declarations
 
-class SceneGeometry;
+class SceneEntity;
 class Camera;
 
@@ -23,4 +22,6 @@
 {
 	friend class Bvh;
+	friend class BvhLoader;
+	friend class myless;
 
 public:
@@ -52,5 +53,4 @@
 	*/
 	BvhNode(BvhNode *parent);
-	
 	/** Returns true if this node is a leaf.
 	*/
@@ -75,13 +75,13 @@
 	virtual void ResetVisibility();
 
-	virtual int GetType() = 0; //{ return BVH_NODE; }
-
-
-	/////////////////////
+	virtual bool IsLeaf() = 0; //{ return BVH_NODE; }
+
+
+	////////////////
 	//-- visibility culling related functions
 
 	inline int GetLastVisitedFrame() const;
 
-	inline void SetLastVisitedFrame(const int lastVisited);
+	inline void SetLastVisitedFrame(int lastVisited);
 	/** If this node is considered visible.
 	*/
@@ -89,8 +89,8 @@
 	/** Set visibility flag of the node.
 	*/
-	inline void SetVisible(const bool visible);
+	inline void SetVisible(bool visible);
 	/** The assumed visible time span of this node.
 	*/
-	inline void SetAssumedVisibleFrames(const int t);
+	inline void SetAssumedVisibleFrames(int t);
 	/** See set.
 	*/
@@ -108,17 +108,28 @@
 	
 	inline int GetTimesInvisible() const;
-	inline void SetTimesInvisible(const int t);
+	inline void SetTimesInvisible(int t);
 	
 	inline int GetTurnedVisibleFrame() const;
-	inline void SetTurnedVisibleFrame(const int turnedVisibleFrame);
+	inline void SetTurnedVisibleFrame(int turnedVisibleFrame);
 
 	inline int GetLastTestedFrame();
-	inline void SetLastTestedFrame(const int lastTested);
+	inline void SetLastTestedFrame(int lastTested);
 	
 	inline bool IsViewFrustumCulled() const;
-	inline void SetViewFrustumCulled(const bool frustumCulled);
+	inline void SetViewFrustumCulled(bool frustumCulled);
 
 	inline bool IsNew() const;
-	inline void SetIsNew(const bool isNew);
+	inline void SetIsNew(bool isNew);
+
+
+	/** Returns the bounding box of this node.
+	*/
+	inline const AxisAlignedBox3 &GetBox() { return mBox; }
+	/** Return index of this node.
+	*/
+	inline int GetId() const { return mId; }
+	/** See get
+	*/
+	inline void SetId(int id) { mId = id; }
 
 
@@ -152,5 +163,5 @@
 	/// the parent node
 	BvhNode *mParent;
-	/// stores the visibility related parameters
+	/// stores the visibility related info
 	VisibilityInfo mVisibility;
 
@@ -181,8 +192,20 @@
 	/// these nodes can be tested instead of the current node
 	int mTestNodesIdx;
+	
 	int mNumTestNodes;
+
 	int mIndicesPtr;
+
 	/// Area of this node
 	float mArea;
+	/// distance to the camera
+	float mDistance;
+	/// the index of this node
+	unsigned int mId;
+	/// indices used for draw array rendering
+	unsigned int *mIndices;
+	/// the bounding box
+	AxisAlignedBox3 mBox;
+
 };
 
@@ -302,7 +325,9 @@
 class BvhInterior: public BvhNode
 {
-friend class Bvh;
+	friend class Bvh;
+	friend class BvhLoader;
 
 public:
+
 	BvhInterior(BvhNode *parent): mBack(NULL), mFront(NULL), BvhNode(parent)
 	{}
@@ -319,5 +344,5 @@
 	/** Returns split axis of this interior node.
 	*/
-	inline int GetAxis() {return (int)mAxis;}
+	inline int GetAxis() { return (int)mAxis; }
 	/** Returns position of the split axis.
 	*/
@@ -337,5 +362,6 @@
 class BvhLeaf: public BvhNode
 {
-friend class Bvh;
+	friend class Bvh;
+	friend class BvhLoader;
 
 public:
@@ -347,4 +373,17 @@
 
 	virtual bool IsLeaf() { return true; }
+};
+
+
+/**	This class implements the compare operator for the priority queue.
+	a lower distance has a higher value in the queue
+*/
+class myless
+{
+public:
+	bool operator() (BvhNode *v1, BvhNode *v2) const
+    {
+		return (v1->mDistance > v2->mDistance);
+    }
 };
 
@@ -354,4 +393,6 @@
 class Bvh
 {
+	friend class BvhLoader;
+
 	/** Bvh properties
 	*/
@@ -401,10 +442,7 @@
 	*/
 	inline int GetNumLeaves() const {return mNumNodes / 2 + 1;}
-	/** Constructs the bounding volume hierarchy.
-	*/
-	void Construct();
 	/** Returns root node of the bvh.
 	*/
-	BvhNode *GetRoot() {return mRoot;}
+	BvhNode *GetRoot() { return mRoot; }
 	/** Counts the triangle in this leaf.
 	*/
@@ -412,9 +450,14 @@
 
 
+	void CollectNodes(BvhNode *node, BvhNodeContainer &nodes, int depth);
+	void CollectNodes(BvhNode *node, BvhNodeContainer &nodes);
+	void CollectLeaves(BvhNode *node, BvhLeafContainer &leaves);
+
+
 	//////////////////////
 
 	/** Returns geometry by reference (faster).
 	*/
-	SceneGeometry **GetGeometry(BvhNode *node, int &size);
+	SceneEntity **GetGeometry(BvhNode *node, int &size);
 
 
@@ -442,21 +485,14 @@
 	*/
 	int	IsWithinViewFrustum(BvhNode *node);
-	/** sets frame dependent values.
-	*/
-	void InitFrame(Camera *camera, const int currentFrameId);
-	/** this gives the orthogonal distance from the viewpoint to the nearest bounding box vertex
+	/** Sets frame dependent values.
+	*/
+	void InitFrame(Camera *camera, int currentFrameId);
+	/** This gives the orthogonal distance from the viewpoint to the nearest bounding box vertex
 		note that negative values can appear because culling is done only afterwards
 	*/
 	float CalcDistance(BvhNode *node) const;
-	/** Sets maximal depth for taking the bounding boxes to test the
-		visibility of a node. The deeper the more the box fits to the geometry.
-	*/
-	void SetMaxDepthForTestingChildren(const int maxDepth);
-	/** Pulls up the fully visible classification in the bvh.
-	*/
-	void UpdateFullVisibility(BvhNode *node) const;
 	/** Pulls up the last visited classification in the bvh.
 	*/
-	void PullUpLastVisited(BvhNode *node, const int frameId) const;
+	void PullUpLastVisited(BvhNode *node, int frameId) const;
 	/** Resets the node classifications in the tree.
 	*/
@@ -465,8 +501,5 @@
 		wireframes for visualization purpose.
 	*/
-	void RenderBoundingBoxesForViz(const int mode);
-	/** Returns squared min distance to the view point.
-	*/
-	float GetSquareDistance(BvhNode *node) const;
+	//void RenderBoundingBoxesForViz(int mode);
 	/** Count triangles the node contains.
 	*/
@@ -477,42 +510,28 @@
 
 
-	////////////
-	//-- functions that change the boundaries of the nodes
-
-	void SetUseTighterBoundsForTests(bool tighterBoundsForTests);
-
-	void SetAreaRatioThresholdForTestingChildren(const float ratio);
-
-
+	////////
+	//-- functions influencing tighter bounds
+
+
+	/** Sets maximal depth for taking the bounding boxes to test the
+		visibility of a node. 
+		Deeper => the bounds adapt more to the geometry.
+	*/
+	void SetMaxDepthForTestingChildren(int maxDepth);
+
+	void SetAreaRatioThresholdForTestingChildren(float ratio);
+
+	/** Returns stats.
+	*/
 	const BvhStats &GetBvhStats() const {return mBvhStats;}
-
-	void SetCollectTighterBoundsWithMaxLevel(bool t);
-
-
-	//////////////
-
-	static unsigned int sCurrentVboId;
 	
 
 protected:
 
-	/** Small struct representing a frustum.
-	*/
-	struct Frustum
-	{
-		/// the 6 clip planes
-		float mClipPlane[6][4];
-	};
-	
-
-
 	////////////////////
 
-	/** Constructor loading the bvh from disc
-	*/
-	Bvh(const std::string &filename);
 	/** protected constructor: do nothing.
 	*/
-	//Bvh(): mCamera(NULL), mFrameId(-1), mVertices(NULL), mRenderer(NULL) {}
+	Bvh();
 	/** Destructor.
 	*/
@@ -534,9 +553,4 @@
 	void RenderBoundingBoxesWithDrawArrays(int numNodes);
 
-	int RenderBoundingBoxesImmediate(const BvhNodeContainer &nodes);
-	/** Renders a bounding box in immediate mode using index restart
-		and restarts the strip only if wished.
-	*/
-	void RenderBoundingBoxImmediate(const AxisAlignedBox3 &box, bool restartStrip);
 	/** Create the indices that each node needs to use vbo rendering.
 	*/
@@ -550,6 +564,6 @@
 	*/
 	void UpdateInteriors(BvhNode *node);
-	/** Recomputes the boundaries of the nodes. This function is always called if
-		some boundary options are changed.
+	/** Recomputes the boundaries of the nodes. 
+	    This function is always called if some boundary options are changed.
 	*/
 	void RecomputeBounds();
@@ -558,12 +572,5 @@
 	*/
 	int PostProcessLeaves(BvhLeafContainer &leaves);
-
-
-	int	IsWithinViewFrustumLocal(BvhNode *node);
-
-	int	IsWithinViewFrustum(const AxisAlignedBox3 &box, int planeMask, int preferredPlane);
-	
-	float GetMinSquareDistance(const AxisAlignedBox3 &box) const;
-	
+		
 	
 	////////////////////////
@@ -572,5 +579,5 @@
 	BvhNode *mRoot;
 	/// pointers to the geometry associated with this node
-	SceneGeometry **mGeometry;
+	SceneEntity **mGeometry;
 	/// #of entities
 	size_t mGeometrySize;
@@ -579,9 +586,4 @@
 	////////////////
 
-
-	/// these values are valid for all nodes
-	char mClipPlaneAABBVertexIndices[6][2];
-	/// the current view frustum
-	Frustum mFrustum;
 	/// the current camera
 	Camera *mCamera;
@@ -589,5 +591,5 @@
 	int mFrameId;
 	/// a vertex array used if working with indexed arrays (without vbo)
-	//Point3f *mVertices;
+	Vector3 *mVertices;
 	/// indices used for draw array rendering
 	unsigned int *mIndices;
@@ -599,9 +601,9 @@
 
 	float mAreaRatioThreshold;
-	float mVolRatioThreshold;
+
 
 	BvhStats mBvhStats;
 
-	//HierarchyNodeContainer mTestNodes;
+	BvhNodeContainer mTestNodes;
 	
 	unsigned int *mTestIndices;
@@ -609,9 +611,10 @@
 	int mCurrentIndicesPtr;
 
-	float mScale;
-
-	Vector3 mNearPlane;
-	float mNearPlaneD;
 	int mNumNodes;
+
+
+	//////////////
+
+	static unsigned int sCurrentVboId;
 };
 
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Plane3.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Plane3.h	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Plane3.h	(revision 2755)
@@ -1,6 +1,7 @@
-#ifndef _Plane3_H__
-#define _Plane3_H__
+#ifndef __Plane3_H__
+#define __Plane3_H__
 
 #include "Vector3.h"
+
 
 namespace CHCDemo 
@@ -15,15 +16,18 @@
 	Plane3() {}
 
+	Plane3(Vector3 &normal, float dist);
+
 	Plane3(const Vector3 &a, const Vector3 &b, const Vector3 &c);
 
 	Plane3(const Vector3 &normal, const Vector3 &point);
 
-	void ReverseOrientation()
+	inline void ReverseOrientation()
 	{
 		mNormal *= -1;
 		mD *= -1;
 	}
-
-	float Distance(const Vector3 &v) const 
+	/** Get disance to point.
+	*/
+	inline float Distance(const Vector3 &v) const 
 	{
 		return DotProd(v, mNormal) + mD;
@@ -31,5 +35,4 @@
 
 	enum {BACK_SIDE = -1, INTERSECTS = 0, FRONT_SIDE = 1};
-
 	/** Returns 1 if v is on front side, -1 if on back side, 0 if on plane.
 	*/
@@ -52,5 +55,5 @@
 
 
-	//////////////////
+	///////////
 	//-- friends
 
@@ -61,5 +64,5 @@
 	friend std::ostream &operator<<(std::ostream &s, const Plane3 &p) 
 	{	
-		s<<p.mNormal<<" "<<p.mD;
+		s << p.mNormal << " " << p.mD;
 		return s;
 	}
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Camera.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Camera.cpp	(revision 2753)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Camera.cpp	(revision 2755)
@@ -1,5 +1,5 @@
 #include "common.h"
 #include "Camera.h"
-
+#include "glInterface.h"
 
 
@@ -70,4 +70,86 @@
 }
 
+
+void Camera::GetProjectionMatrix(Matrix4x4 &mat)
+{
+	//float m[16];
+	
+	glGetFloatv(GL_PROJECTION_MATRIX, (float *)mat.x);
+	//mat = Matrix4x4((const float *)m);
 }
 
+
+void Camera::GetModelViewMatrix(Matrix4x4 &mat)
+{
+	//float m[16];
+
+	glGetFloatv(GL_MODELVIEW_MATRIX, (float *)mat.x);
+	//mat = Matrix4f((const float *)m);
+}
+
+
+void Camera::CalcFrustum(Frustum &frustum)
+{
+	// we grab the plane equations of the six clipplanes of the viewfrustum
+	Matrix4x4 matViewing, matProjectionView;
+
+	GetModelViewMatrix(matViewing);
+	GetProjectionMatrix(matProjectionView);
+
+	matProjectionView *= matViewing;
+
+	
+	float fInvLength;
+
+	float planes[6][4];
+
+	//////////
+	//-- extract the plane equations
+
+	for (int i = 0; i < 4; ++ i)
+	{
+		planes[0][i] = matProjectionView.x[i][3] - matProjectionView.x[i][0]; // right plane
+		planes[1][i] = matProjectionView.x[i][3] + matProjectionView.x[i][0]; // left plane
+		planes[2][i] = matProjectionView.x[i][3] + matProjectionView.x[i][1]; // bottom plane
+		planes[3][i] = matProjectionView.x[i][3] - matProjectionView.x[i][1]; // top plane
+		planes[4][i] = matProjectionView.x[i][3] - matProjectionView.x[i][2]; // far plane
+		planes[5][i] = matProjectionView.x[i][3] + matProjectionView.x[i][2]; // near plane
+	}
+
+
+	////////////
+	//-- normalize the coefficients
+
+	for (int i = 0; i < 6; ++ i)
+	{
+		// the clipping planes look outward the frustum,
+		// so distances > 0 mean that a point is outside
+		fInvLength	= -1.0f / sqrt(planes[i][0] * planes[i][0] +	
+								   planes[i][1] * planes[i][1] +	
+								   planes[i][2] * planes[i][2]);
+
+		planes[i][0] *= fInvLength;
+		planes[i][1] *= fInvLength;
+		planes[i][2] *= fInvLength;
+		planes[i][3] *= fInvLength;
+
+		Vector3 normal(planes[i][0], planes[i][1], planes[i][2]);
+		frustum.mClipPlanes[i] = Plane3(normal, planes[i][3]);
+	}
+}
+
+
+void Camera::Frustum::CalcNPVertexIndices(int *indices)
+{
+	for (int i = 0; i < 6; ++ i)
+	{
+		// n-vertex
+		indices[i * 2 + 0] = AxisAlignedBox3::GetIndexNearestVertex(mClipPlanes[i].mNormal);
+		// p-vertex
+		indices[i * 2 + 1] = AxisAlignedBox3::GetIndexFarthestVertex(mClipPlanes[i].mNormal);	
+	}
+}
+
+
+}
+
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/common.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/common.h	(revision 2754)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/common.h	(revision 2755)
@@ -25,4 +25,6 @@
 class BvhLeaf;
 class OcclusionQuery;
+class SceneEntity;
+
 
 
@@ -465,4 +467,5 @@
 
 typedef std::vector<BvhNode *> BvhNodeContainer;
+typedef std::vector<SceneEntity *> SceneEntityContainer;
 typedef std::vector<BvhLeaf *> BvhLeafContainer;
 typedef std::vector<Triangle3> TriangleContainer;
